<?php
/*
		Plugin Name: PubMan Content 
		Plugin URI: http://colab.mpdl.mpg.de/mediawiki/User:Andi/PubMan_Wordpress_Plugin
		Description: Plugin to fetch contents from PubMan and display it
		Author: Andreas Gros 
		Author URI:http://colab.mpdl.mpg.de/mediawiki/User:Andi
*/

/*  Copyright 2008  Andreas Gros  (email : gros@mpdl.mpg.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


     	if(!class_exists("PubManPlugin")){

				class PubManPlugin {
					//for administration
					var $adminOptionsName = "PubManPluginAdminOptions";
					var $availableCitationStyles = array("APA");
					//for display
					var $defaultNumberOfItemsPerPage = 10;
					var $distanceForTearOffPages = 4;			    // |< < 1 ... 5 6 7 8 9 ... 20 > >|
					var $distanceSurroundingCurrentPage = 2;  //                = 

					function PubManPlugin(){ // constructor
						add_action('plugins_loaded', array(&$this, 'init_pubman'));
						
						// Hook for theme coders/hackers
            add_action('pubman_content', array(&$this, 'display_pubmancontent'));

            // Makes it backwards compat pre-2.5 I hope
            if ( function_exists('add_shortcode') ) {
                add_shortcode('pubman-content', array(&$this, 'my_shortcode_handler'));
             }
						$this->getAdminOptions();
					}

					//************** init: called upon plugin installation + instantiation *****************
					function init() {
						$this->getAdminOptions();
					}
						
					//************** Get/Set the options *****************
					function getAdminOptions(){
						//set the default option values
						$pubmanContentAdminOptions = array('baseURLPubMan' => 'http://pubman.mpdl.mpg.de',
																							 'pathItemView' => '/pubman/item/',
																							 'pathSearchAndExport' => '/search/SearchAndExport?cqlQuery=',
																							 'defaultCitationStyle' => 'APA',
																							 'defaultTextForPublicationLink' => '[LINK]',
																							 'defaultSearchString' => 'escidoc.metadata=sengbusch',
																							 'defaultSortKey' => 'escidoc.issued,,0',
																							 'numberOfItemsPerPage' => $this->defaultNumberOfItemsPerPage); 
						//check for previously set option values
						$pubmanOptions = get_option($this->adminOptionsName);
						if(!empty($pubmanOptions)){
							foreach($pubmanOptions as $key => $option) {	$pubmanContentAdminOptions[$key] = $option;	}
						}
						update_option($this->adminOptionsName, $pubmanContentAdminOptions);
						return $pubmanContentAdminOptions;
					}

					//************** Enable display with correct css settings (add pubman-css) *****************
					function addHeaderCode() {
						echo '<link type="text/css" rel="stylesheet" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/pubman/css/pubman.css" />';	
					}
					


					//********************widget functions********************
					function pubman_widget() {
						$pubmanOptions = get_option($this->adminOptionsName);

						echo"<h2>PubMan Content</h2> \n";
						$this->display_pubmancontent(array("searchstring" => $pubmanOptions['defaultSearchString'], 
																							 "citationstyle" => $pubmanOptions['defaultCitationStyle']));
					}

					function init_pubman(){
						if ( !function_exists('register_sidebar_widget') )
							return;
						register_sidebar_widget("PubMan", "pubman_widget");     
					}


					//********************get content out of pubman********************
					function display_pubmancontent($atts) {
						global $state;
						global $publicationdata;
						global $publicationcount;
					  $tstr = "";	
						$pubmanOptions = get_option($this->adminOptionsName);
						$itemsPerPage = floatval($pubmanOptions['numberOfItemsPerPage']);
						$publicationcount = 0;
						
						if(is_array($atts)) {
							$searchString = $atts['searchstring'];	
							if(utf8_encode(utf8_decode($atts['searchstring']))==$atts['searchstring']) { //to enable umlauts in the search string, e.g. gemüse
								$searchString		= utf8_decode($atts['searchstring']);
								}
							$citationStyle	= $atts['citationstyle'];
							}
						if(!isset($citationStyle) || (strlen($citationStyle) == 0)) {$citationStyle =  $pubmanOptions['defaultCitationStyle']; }
						if(!isset($searchString) || (strlen($searchString) == 0)) {$searchString = $pubmanOptions['defaultSearchString']; }
						$searchURL = $pubmanOptions['baseURLPubMan'] . $pubmanOptions['pathSearchAndExport'];
						$request = $searchURL . $searchString . "&exportFormat=" . $citationStyle;
						$request .= "&sortKeys=" . $pubmanOptions['defaultSortKey']  . "&outputFormat=snippet&language=all";
						$snippet = file_get_contents($request);
						$state='';
						if (!($xml_parser = xml_parser_create()))
							die("Couldn't create parser.");
						xml_set_element_handler($xml_parser,"startElementHandler","endElementHandler");
						xml_set_character_data_handler( $xml_parser, "characterDataHandler");

						$retstr = "";
						if(!xml_parse($xml_parser, $snippet)) {
							$retstr = sprintf("XML error: %s at line %d",
												xml_error_string(xml_get_error_code($xml_parser)),
												xml_get_current_line_number($xml_parser));
							}
						xml_parser_free($xml_parser);
						if(strlen($retstr)==0) {
							$paginatorstr = "";
							$pageToDisplay = 1;
							$numPages = ceil($publicationcount/$itemsPerPage);

							if (is_front_page()) { $showPaginator = 0; } //don't show the paginator on the front page (workaround for 
							else {																			 //get_posts-on-frontpage-bug of wordpress 2.6
								$showPaginator = 1; 
								if(is_category()) //don't show the paginator if the category has subcategories 
									{							  //or multiple posts in it
									$current_category = single_cat_title("", false);
									$mycat = get_cat_id($current_category); 
									$has_cat_children = (bool)(get_category_children($mycat));
									$posts = get_posts(array('category' => $mycat, 'post_parent' => null) );
									if($has_cat_children || (count($posts) > 1)) { $showPaginator = 0; }
									}
								else { //there can be multiple posts in one category
									$posts = get_posts(array('post_parent' => get_the_ID()) );
									if((count($posts)>1)) $showPaginator = 0;
									}
								}
							//check if paging is needed or has already been started
							if(($publicationcount > $itemsPerPage) && ($showPaginator == 1)) {
								$tpd = 1;
								if(isset($_GET['pd']) && (is_numeric($tpd = $_GET['pd'])) && ($tpd > 0) && ($tpd <= $numPages)) {
									$pageToDisplay = $tpd;		
									}
								//calculate from which item to which item to display 
								$fromItem = intval(($pageToDisplay - 1)*$itemsPerPage);
								$toItem = min($publicationcount, intval(($pageToDisplay*$itemsPerPage)));
								
								$rURL = $_SERVER['REQUEST_URI'];
								//clear request uri from previous page requests
								if(($ppos = strpos($rURL, "&pd=")) > 0){
									$rURL = substr($rURL, 0, $ppos);
									}
								if(($ppos = strpos($rURL, "?pd=")) > 0){
									$rURL = substr($rURL, 0, $ppos);
									}
								if(strpos($rURL, "?") > 0)	{ $rURL .= "&pd="; }
								else { $rURL .= "?pd="; }
								//assemle the paginator line
								$paginatorstr = "<a href='" . $rURL . "1'>|&lt;</a>&nbsp;";
								$paginatorstr .="<a href='" . $rURL . max(($pageToDisplay - 1), 1) . "'>&lt;</a>&nbsp;&nbsp;&nbsp;";
								if($pageToDisplay == 1) { $paginatorstr .= "<strong>1</strong>&nbsp;"; }
								else {										$paginatorstr .="<a href='" . $rURL . "1'>1</a>&nbsp;"; }
								//check if ... have to be inserted, e.g.
								// |< < 1 ... 5 6 7 8 9 ... 20 > >|
								//                = 
								$paddDots = 0;    
								$pfrom    = 2;
								$pto      = $numPages - 1;                
								if($pageToDisplay - $this->distanceSurroundingCurrentPage - $this->distanceForTearOffPages > 0) {
									$paginatorstr .="<a id='dots'>.&thinsp;.&thinsp;.</a>&nbsp;";	
									if($pageToDisplay + $this->distanceSurroundingCurrentPage + $this->distanceForTearOffPages > $numPages) {
									  $pfrom = max(1, $numPages - $this->distanceSurroundingCurrentPage - $this->distanceForTearOffPages);	 
										}
									else { $pfrom = $pageToDisplay-$this->distanceSurroundingCurrentPage; }
									}
								else { $pto = min(1 + $this->distanceSurroundingCurrentPage + $this->distanceForTearOffPages, $numPages - 1); }	
								
								if($pageToDisplay + $this->distanceSurroundingCurrentPage + $this->distanceForTearOffPages <= $numPages) {
									$pto   = ($pto < $numPages - 1) ? $pto : $pageToDisplay+$this->distanceSurroundingCurrentPage;
									$paddDots = 1;
									}
									
								for($i=$pfrom; $i <= $pto; $i++){
									if($i == $pageToDisplay){
										$paginatorstr .= "<strong>" . $i . "</strong>&nbsp;";
										}
									else {
										$paginatorstr .="<a href='" . $rURL . $i . "'>" . $i . "</a>&nbsp;";
										}	
									}
								if($paddDots == 1){	$paginatorstr .="<a id='dots'>.&thinsp;.&thinsp;.</a>&nbsp;";	}
								
								if($pageToDisplay == $numPages) { $paginatorstr .= "<strong>" . $numPages . "</strong>&nbsp;"; }
								else {
									$paginatorstr .="<a href='" . $rURL . $numPages . "'>" . $numPages . "</a>&nbsp;";
								  }
								$paginatorstr .= "&nbsp;&nbsp;<a href='" . $rURL . min(($pageToDisplay + 1), $numPages) . "'>&gt;</a>&nbsp;";
								$paginatorstr .= "<a href='" . $rURL . $numPages . "'>&gt;|</a>";
								$paginatorstr = "<div id='ppaginator'>" . $paginatorstr . "</div> \n";
								}
							else if(($publicationcount > $itemsPerPage) && ($showPaginator == 0)) {
								$fromItem = 0;
								$toItem		= $itemsPerPage;
								}
							else { //there were less items than fit on a page
								$fromItem = 0;
								$toItem		= $publicationcount;
								}
							$retstr .= $paginatorstr;	
							for ($i = $fromItem; $i < $toItem; $i++) {
									$retstr .= str_replace("<br/>", "", $publicationdata[$i]["citation"]) . "&nbsp;<a href=\"" . $pubmanOptions['baseURLPubMan']  . $pubmanOptions['pathItemView']  . $publicationdata[$i]["escidocitem"] . "\" >" . $pubmanOptions['defaultTextForPublicationLink'] . "</a><br/><br/>\n";
								}
							$retstr .= $paginatorstr;
							if(($publicationcount > $itemsPerPage) && ($showPaginator == 0)) { //show a "more ..."-link
								$ppost = get_post(get_the_ID(), ARRAY_A);
								$retstr .= "<div style='width:100%; text-align:right;'><a href='" . $ppost['guid'] . "'>read more ...</a></div>";	
								}
							} //there was an error message
						return $retstr;
						}


					function my_shortcode_handler($atts, $content=null) {
            //global $settings;
            //$settings = get_option($this->adminOptionsName);
            return $this->display_pubmancontent($atts);
            //unset($settings);
					}
					
					// *********** inline replacement callback support **************
					function inline_replace_callback($matches) {

            if ( ! strlen($matches[1]) ) { // Default
                $searchstring = '';
            } else {
                $searchstring = substr($matches[1], 1); // Skip 
            }
            return $this->display_pubmancontent($searchstring);
					}


				// *********** Admin Options **************
				function printAdminPage() {
          $pubmanOptions = $this->getAdminOptions();

          if (isset($_POST['update_pubmanContentSettings'])) {
            if (isset($_POST['baseURLPubMan'])) {
              $pubmanOptions['baseURLPubMan'] = $_POST['baseURLPubMan'];
            }   
            if (isset($_POST['pathItemView'])) {
              $pubmanOptions['pathItemView'] = $_POST['pathItemView'];
            }   
            if (isset($_POST['pathSearchAndExport'])) {
              $pubmanOptions['pathSearchAndExport'] = $_POST['pathSearchAndExport'];
            }   
            if (isset($_POST['defaultCitationStyle'])) {
              $pubmanOptions['defaultCitationStyle'] = $_POST['defaultCitationStyle'];
            }   
            if (isset($_POST['defaultTextForPublicationLink'])) {
              $pubmanOptions['defaultTextForPublicationLink'] = $_POST['defaultTextForPublicationLink'];
            }   
            if (isset($_POST['defaultSearchString'])) {
              $pubmanOptions['defaultSearchString'] = $_POST['defaultSearchString'];
            } 
            if (isset($_POST['defaultSortKey'])) {
              $pubmanOptions['defaultSortKey'] = $_POST['defaultSortKey'];
            } 
						if (isset($_POST['numberOfItemsPerPage']) && is_numeric($_POST['numberOfItemsPerPage']) && ($_POST['numberOfItemsPerPage'] > 0)) {
              $pubmanOptions['numberOfItemsPerPage'] = $_POST['numberOfItemsPerPage'];
            }   
						
          update_option($this->adminOptionsName, $pubmanOptions);
           ?>

<div class="updated"><p><strong><?php _e("Settings Updated.", "PubMan Content Plugin");?></strong></p></div>

       <?php

      } ?>
      <div class=wrap>
      <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
      <h2>PubMan Content Plugin</h2>
      <h3>Set the base URL for PubMan</h3>
			<p><label for="updateBaseURLPubMan"><input type="text" id="baseURLPubMan" name="baseURLPubMan" value="<?php if (strlen($pubmanOptions['baseURLPubMan'])>0) _e($pubmanOptions['baseURLPubMan']); ?>" /> Base-URL, e.g. http://pubman.mpdl.mpg.de</label><br/></p>
      <h3>Set path to full item view in PubMan</h3>
			<p><label for="updatePathItemView"><input type="text" id="pathItemView" name="pathItemView" value="<?php if (strlen($pubmanOptions['pathItemView'])>0) _e($pubmanOptions['pathItemView']); ?>" /> Item description, e.g. /pubman/item/ </label><br/></p>
      <h3>Set path to the Search&Export interface in PubMan</h3>
			<p><label for="updateSearchAndExport"><input type="text" id="pathSearchAndExport" name="pathSearchAndExport" value="<?php if (strlen($pubmanOptions['pathSearchAndExport'])>0) _e($pubmanOptions['pathSearchAndExport']); ?>" /> Search&amp;Export interface, e.g. /search/SearchAndExport?cqlQuery= </label><br/></p>
     
		  <h3>Set the default text for the link to the full item view</h3>
			<p><label for="updateDefaultTextForPublicationLink"><input type="text" id="defaultTextForPublicationLink" name="defaultTextForPublicationLink" value="<?php if (strlen($pubmanOptions['defaultTextForPublicationLink'])>0) _e($pubmanOptions['defaultTextForPublicationLink']); ?>" /> Default text, e.g. [LINK]</label><br/></p>
		  <h3>Set the default search string</h3>
			<p><label for="updateDefaultSearchString"><input type="text" id="defaultSearchString" name="defaultSearchString" value="<?php if (strlen($pubmanOptions['defaultSearchString'])>0) _e($pubmanOptions['defaultSearchString']); ?>" /> Default search string</label><br/></p>
			 <h3>Set the default sort key</h3>
			<p><label for="updateDefaultSortKey"><input type="text" id="defaultSortKey" name="defaultSortKey" value="<?php if (strlen($pubmanOptions['defaultSortKey'])>0) _e($pubmanOptions['defaultSortKey']); ?>" /> Default sort key</label><br/></p>
      <h3>Set the numer of items per page</h3>
			<p><label for="updateNumberOfItemsPerPage"><input type="text" id="numberOfItemsPerPage" name="numberOfItemsPerPage" value="<?php  _e($pubmanOptions['numberOfItemsPerPage']); ?>" /> Number of items per page</label><br/></p>
			
			<h3>Set the default citation style</h3>
      <p><label for="defaultCitationStyle_yes"><select id="defaultCitationStyle" name="defaultCitationStyle"><?php 
			foreach($this->availableCitationStyles as $style){
				if($style == $pubmanOptions['defaultCitationStyle']) {$optionstr = '<option selected="selected">';}
				else {$optionstr = "<option>";}
				_e($optionstr . $style . "</option>");
			}
			 ?>
			</select> Available citation styles</label>
       
      <div class="submit">
      <input type="submit" name="update_pubmanContentSettings" value="<?php _e('Update Settings', 'PubManContentPlugin') ?>" /></div>
      </form>
       </div>
<?php
					}//End function printAdminPage()
				}//end class 	
			}//end if !class exists

if(class_exists("PubManPlugin")){
	$pubmanPlugin = new PubManPlugin();	
}

//Initialize the admin panel
if (!function_exists("PubManContentPlugin_ap")) {
	function PubManContentPlugin_ap() {
		global $pubmanPlugin;
		if (!isset($pubmanPlugin)) {
			return;
		}
		if (function_exists('add_options_page')) {
			add_options_page('PubMan Content Plugin', 'PubMan Content Plugin Config', 9, basename(__FILE__), array(&$pubmanPlugin, 'printAdminPage'));
		}
	}	
}
if (isset($pubmanPlugin)) {
	//Actions
	add_action('admin_menu', 'PubManContentPlugin_ap');
	add_action('activate_pubman/pubman_plugin.php',  array(&$pubmanPlugin, 'init'));
	add_action('wp_head', array(&$pubmanPlugin, 'addHeaderCode'), 1);
}


//***********************support functions for parsing xml (depends on expat)***********************
function startElementHandler ($parser,$name,$attrib){
	global $state;
	global $publicationdata;
	global $publicationcount;

	switch ($name) {
		case $name=="DCTERMS:BIBLIOGRAPHICCITATION" : {
			$state = "citation";
			break;
		}
		case $name=="ESCIDOCITEM:ITEM" : {
			$publicationdata[$publicationcount]["escidocitem"] = $attrib['OBJID'];
			break;
		}
	}
}
	
function endElementHandler ($parser,$name){
	global $publicationcount;
	global $state;
	$state='';
	if($name=="DCTERMS:BIBLIOGRAPHICCITATION") {$publicationcount++;}
}

function characterDataHandler ($parser, $data) {
	global $publicationdata;
	global $publicationcount;
	global $state;
	if (!$state) {return;}
	if ($state=="citation") { $publicationdata[$publicationcount]["citation"] = $data;}
}
			
?>
